﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Composite.Data;
using System.Globalization;
using Composite.Data.Plugins.DataProvider;


namespace Sample.DataProvider.CultureData
{
    /// <summary>
    /// Class implementing our data interface ICulture - holding instances of our data.
    /// This is constructed by our provider as is the class that convey actual data to Composite C1.
    /// Composite.Data.Hierarchy.DataAncestorProviderAttribute
    /// </summary>
    /// 
   
    public class CultureDataItem : ICultureData
    {
        internal CultureDataItem(CultureInfo cultureInfo, DataProviderContext dataProviderContext)
        {
            this.DataSourceId = dataProviderContext.CreateDataSourceId(new CultureDataItemId { CultureInfo = cultureInfo }, typeof(ICultureData));
        }

        private CultureInfo MyCultureInfo
        {
            get
            {
                return ((CultureDataItemId)this.DataSourceId.DataId).CultureInfo;
            }
        }

        public string DisplayName
        {
            get
            {
                return MyCultureInfo.DisplayName;
            }
        }

        public string EnglishName
        {
            get
            {
                return MyCultureInfo.EnglishName;
            }
        }

        public int LCID
        {
            get
            {
                return MyCultureInfo.LCID;
            }
        }

        public string Name
        {
            get
            {
                return MyCultureInfo.Name;
            }
        }

        public string ThreeLetterISOLanguageName
        {
            get
            {
                return MyCultureInfo.ThreeLetterISOLanguageName;
            }
        }

        public DataSourceId DataSourceId {get; set;}
    }
}
